
// modified from http://techpatterns.com/downloads/javascript_cookies.php

// use expires==null for a session cookie
function setCookie(name,value,expires,path,domain,secure) {
    var today = new Date(); // set time, it's in milliseconds

    today.setTime(today.getTime());

    // convert expires in days to expires in mSec
    if (expires) expires *= 24 * 60 * 60 * 1000;

    var expires_date = new Date(today.getTime() + (expires));

    document.cookie = name + "=" +escape(value) +
        ((expires) ? ";expires=" + expires_date.toGMTString() : "") +
        ((path   ) ? ";path=" + path : "") +
        ((domain ) ? ";domain=" + domain : "") +
        ((secure ) ? ";secure" : "" );
}
 
// this fixes an issue with the old method, ambiguous values
// with this test document.cookie.indexOf( name + "=" );
function getCookie(name) {
    var a, key, value;

    // first we'll split this cookie up into name/value pairs
    // note: document.cookie only returns name=value, not the other components
    var keyvals = document.cookie.split(';');
 
    for (var i=0; i<keyvals.length; i++ ) {

        // split apart each name=value pair
        a    = keyvals[i].split('=');
        key  = a[0];
        value= (a.length > 1) ? a[1] : ""; // if cookie exists without =value

        // trim left/right whitespace while we're at it
        key = key.replace(/^\s+|\s+$/g, '');

        // if the extracted name matches passed check_name
        if (key == name) return unescape(value.replace(/^\s+|\s+$/g, ''));
    }
    return null;
}

// this deletes the cookie when called (or when the browser closes)
function delCookie(name, path, domain) {

    if (!getCookie(name)) return;

    document.cookie = name + "=" +
        ((path   ) ? ";path=" + path : "") +
        ((domain ) ? ";domain=" + domain : "") +
                     ";expires=Thu, 01-Jan-1970 00:00:01 GMT";
}

