

function Resizer() {
    this.dw= document.documentElement.clientWidth -4;
    this.dh= document.documentElement.clientHeight-4;
    var aspect_width = this.dw;
    var aspect_height= this.dh;
    this.aw= this.dw;
    this.ah= this.dh;
    
    this.setAspectRatio = function (w,h) {
        aspect_width = w;  // units are independent of device pixels
        aspect_height= h;  // could be 10000 or 0.794
    }

    this.resize = function () {
        this.dw= document.documentElement.clientWidth -4; // allow 2px app border
        this.dh= document.documentElement.clientHeight-4;

        var scaleX= this.dw/aspect_width;
        var scaleY= this.dh/aspect_height;
        var scale= Math.min(scaleX,scaleY);
        this.aw = parseInt(scale*aspect_width ,10);
        this.ah = parseInt(scale*aspect_height,10);
    }

    this.size  = function (x) { return parseInt(x*this.ah+0.5,10); }
    this.sizew = function (x) { return parseInt(x*this.aw+0.5,10); }

    this.resizeAppDiv = function (Id) {
        var o= document.getElementById(Id);
        o.style.marginLeft  = parseInt((this.dw-this.aw)/2,10)+"px";
        o.style.marginTop   = parseInt((this.dh-this.ah)/2,10)+"px";
        o.style.width = this.aw+"px"; // assumes 0 margin, border, padding for app
        o.style.height= this.ah+"px";
    }

    this.resizeId = function (Id,dx,dy) {
        var o= document.getElementById(Id);
        o.width =dx;
        o.height=dy;
    }

    this.resizeIdStyle = function (Id,x,y,dx,dy) {
        var o= document.getElementById(Id);
        o.style.left  = parseInt(x+0.5,10)+"px";
        o.style.top   = parseInt(y+0.5,10)+"px";
        o.style.width = contentWidth( o,dx)+"px";
        o.style.height= contentHeight(o,dy)+"px";
    }

    this.resizeDivImg = function (div,img,x,y,dx,dy) {
        this.resizeIdStyle(div,x,y,dx,dy);
        this.resizeId(img,dx,dy);
    }

    this.resizeIdFont = function (Id,dy) {
        document.getElementById(Id).style.fontSize=parseInt(dy+0.5,10)+"px";
    }

    this.resizeButton = function (id,x,y,w,h,frac) {
        var o = document.getElementById(id);
        var h0= h-2; // 1px border. cant use contentHeight() because we change padding
        var h1= parseInt(frac*h0+0.5,10);
        var h2= parseInt((h0-h1)/2,10);
        o.style.left  = parseInt(x+0.5,10)+"px";
        o.style.top   = parseInt(y+0.5,10)+"px";
        o.style.width = contentWidth( o,w)+"px";
        o.style.height= h1+"px";
        o.style.fontSize=h1+"px";
        o.style.paddingTop=    h2+"px";
        o.style.paddingBottom= h2+"px";
    }
    this.resizeBtn = function (id,x,y,w,h,fsize) {
        var aw= this.aw;
        var ah= this.ah;
        var o = document.getElementById(id);
        var h0= h*ah -bt(o)-bb(o); // 1px border. cant use contentHeight() because we change padding
        var h1= parseInt(fsize*ah+0.5,10);
        var h2= parseInt((h0-h1)/2,10);
        o.style.left  = parseInt(x*aw+0.5,10)+"px";
        o.style.top   = parseInt(y*ah+0.5,10)+"px";
        o.style.width = contentWidth(o,w*aw)+"px";
        o.style.height=  h1+"px";
        o.style.fontSize=h1+"px";
        o.style.paddingTop=    h2+"px";
        o.style.paddingBottom= h2+"px";
    }

    this.resizeDivFont = function (id,x,y,w,h,fsize) {
        var aw= this.aw;
        var ah= this.ah;
        var o = document.getElementById(id);
        var h0= h*ah -bt(o)-bb(o); // 1px border. cant use contentHeight() because we change padding
        var h1= parseInt(fsize*ah+0.5,10);
        var h2= parseInt((h0-h1)/2,10);
        o.style.left  = parseInt(x*aw+0.5,10)+"px";
        o.style.top   = parseInt(y*ah+0.5,10)+"px";
        o.style.width = contentWidth(o,w*aw)+"px";
        o.style.height=  h1+"px";
        o.style.fontSize=h1+"px";
        o.style.paddingTop=    h2+"px";
        o.style.paddingBottom= h2+"px";
    }
    this.resizeList = function (id,x,y,w,h,fsize) { // <select size=n>...</select>
        var aw= this.aw;
        var ah= this.ah;
        var o = document.getElementById(id);
        var h0= h*ah -bt(o)-bb(o); 
        o.style.left  = parseInt(x*aw+0.5,10)+"px";
        o.style.top   = parseInt(y*ah+0.5,10)+"px";
        o.style.width = contentWidth(o,w*aw)+"px";
        o.style.height=  h0+"px";
        o.style.fontSize=parseInt(fsize*ah+0.5,10)+"px";
    }
    function mt(o) { var x=parseInt(o.style.marginTop   ,10); if (isNaN(x)) x=0; return x; }
    function mb(o) { var x=parseInt(o.style.marginBottom,10); if (isNaN(x)) x=0; return x; }
    function bt(o) { var x=parseInt(o.style.borderTop   ,10); if (isNaN(x)) x=0; return x; }
    function bb(o) { var x=parseInt(o.style.borderBottom,10); if (isNaN(x)) x=0; return x; }

    function contentWidth(o,dx) {
        var w= parseInt(dx+0.5,10);
        var deducts = [ o.style.marginLeft, o.style.borderLeft, o.style.paddingLeft,
               o.style.marginRight, o.style.borderRight, o.style.paddingRight];
        for (var i=0; i<deducts.length; i++) {
            var x = parseInt(deducts[i],10); if (isNaN(x)) x=0;
            w -= x;
        }
        return w;
    }
    function contentHeight(o,dy) {
        var h= parseInt(dy+0.5,10);
        var deducts = [ o.style.marginTop, o.style.borderTop, o.style.paddingTop,
               o.style.marginBottom, o.style.borderBottom, o.style.paddingBottom];
        for (var i=0; i<deducts.length; i++) {
            var x = parseInt(deducts[i],10); if (isNaN(x)) x=0;
            h -= x;
        }
        return h;
    }
}
